package small.test;

import java.io.IOException;

import javax.inject.Inject;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.ops4j.pax.exam.CoreOptions;
import org.ops4j.pax.exam.Option;
import org.ops4j.pax.exam.junit.Configuration;
import org.ops4j.pax.exam.junit.ExamReactorStrategy;
import org.ops4j.pax.exam.junit.JUnit4TestRunner;
import org.ops4j.pax.exam.spi.reactors.AllConfinedStagedReactorFactory;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.service.cm.ConfigurationAdmin;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@RunWith( JUnit4TestRunner.class )
@ExamReactorStrategy( AllConfinedStagedReactorFactory.class )
public class SimpleTest
{
   private static final Logger LOGGER = LoggerFactory.getLogger( SimpleTest.class );
   @Inject
   private ConfigurationAdmin  configAdmin;
   @Inject
   private BundleContext       bundleContext;

   @Configuration
   public static Option[] config()
   {
      return CoreOptions
         .options( CoreOptions.mavenBundle( "org.apache.felix", "org.apache.felix.configadmin", "1.2.8" ) );
   }

   @Test
   public void testConfigurationAdmin() throws IOException
   {
      try
      {
         configAdmin.createFactoryConfiguration( "ladida" );
      }
      catch( final Exception ex )
      {
         LOGGER.error( "nullPointer on configadmin", ex );
      }
      // we got no problem if we just lookup the service with the bundleContext
      ConfigurationAdmin service = null;
      service = receiveConfigurationAdmin( service );
      service.createFactoryConfiguration( "ladida" );
   }

   private ConfigurationAdmin receiveConfigurationAdmin( ConfigurationAdmin service )
   {
      final ServiceReference serviceReference = bundleContext
         .getServiceReference( "org.osgi.service.cm.ConfigurationAdmin" );
      if( serviceReference != null )
      {
         service = (ConfigurationAdmin) bundleContext.getService( serviceReference );
      }
      return service;
   }

}
